#include <SoftwareSerial.h> // Library für die Kommunikation per Bluetooth
#include <Servo.h> // Library zur Steuerung von Servos

// Definition der Pins
int bluetoothTx = 0;
int bluetoothRx = 1;
int led = 5;
int poti = 0;
int schalterOben = 13;
int schalterUnten = 12;
int servo = 10;

// Definition der Variablen
int Fall, bluetoothWert, valuePoti, zustandSchalterOben, zustandSchalterUnten;

// Bluetooth
SoftwareSerial bluetooth(bluetoothTx, bluetoothRx);

// Servo
Servo myservo;

void setup() {
  // Bluetooth initalisieren und Baudrate festlegen
  Serial.begin(9600);
  bluetooth.begin(9600);

  // Servo mit oben definiertem Pin hinzufügen
  myservo.attach(servo);

  // PinModes setzen
  pinMode(led, OUTPUT);
  pinMode(schalterOben, INPUT);
}

void loop() {
  // Wert des Potis und der beiden Endschalter auslesen
  int valuePoti = analogRead(poti);
  int zustandSchalterOben = digitalRead(schalterOben);
  int zustandSchalterUnten = digitalRead(schalterUnten);

  if (bluetooth.available() > 0 )
  {
    int bluetoothWert = bluetooth.read();
    Serial.println(bluetoothWert);
  }

  // Über den Wertebereich des Potis < 10 den Modus für die
  // Bluetooth-Steuerung aktivieren
  if (valuePoti < 10)
  {
    Fall = 0;
  }
  else if (valuePoti > 10)
  {
    Fall = 1;
  }


  switch (Fall) {
    case 0: // Steuerung per Bluetooth
      {
        if ((bluetoothWert == 48) && (zustandSchalterUnten == 1))
        {
          myservo.write(0);
          digitalWrite(led, LOW);
        }
        else if ((bluetoothWert == 49) && (zustandSchalterOben == 1))
        {
          myservo.write(180);
          digitalWrite(led, HIGH);
        }
        else
        {
          // Servo stoppen
          myservo.write(90);
        }
        break;
      }
    case 1: // Steuerung per Potentiometer
      {
        if ((valuePoti >= 150) && (valuePoti < 300) && (zustandSchalterUnten == 1))
        {
          myservo.write(0);
          digitalWrite(led, LOW);
        }
        else if ((valuePoti >= 900) && (valuePoti <= 1023) && (zustandSchalterOben == 1))
        {
          myservo.write(180);
          digitalWrite(led, HIGH);
        }
        else
        {
          // Servo stoppen
          myservo.write(90);
        }
        break;
      }
    default:
      {
        break;
      }
  }
}
